# PresentSelector

Extends \BaseSelector

Selector that filters files based on whether they appear in another directory tree. It can contain a mapper element, so isn't available as an ExtendSelector (since those parameters can't hold other elements).

This class handles the common description attribute and provides a default implementation for reference handling and checking for circular references that is appropriate for types that can not be nested inside elements of the same type (i.e. patternset but not path)

author | Hans Lellelid hans@xmpl.org (Phing)
author | Bruce Atherton bruce@callenish.com (Ant)
package | phing.types.selectors

### Methods

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference() : \BuildException

inherited

### Response

`\BuildException`

## Defines the FileNameMapper to use (nested mapper element).

    createMapper() : \Mapper

throws |

### Response

`\Mapper`

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference( &$stk, \Project $p) : void

inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

throws |

### Arguments

#### $stk

``

#### $p

`\Project`

## Performs the check for circular references and returns the referenced object.

    getCheckedRef( $requiredClass,  $dataTypeName) : mixed

inherited

throws |

### Arguments

#### $requiredClass

``

#### $dataTypeName

``

### Response

`mixed`

## Return the description for the current data type.

    getDescription()

inherited

retujrn | string

## Returns any error messages that have been set.

    getError() : string

inherited

### Response

`string`

the error condition

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Has the refid attribute of this element been set?

    isReference() : boolean

inherited

### Response

`boolean`

## The heart of the matter. This is where the selector gets to decide on the inclusion of a file in a particular fileset.

    isSelected(\PhingFile $basedir, string $filename, \PhingFile $file) : boolean

throws |

### Arguments

#### $basedir

`\PhingFile`

base directory the scan is being done from

#### $filename

`string`

the name of the file to check

#### $file

`\PhingFile`

a PhingFile object the selector can use

### Response

`boolean`

whether the file should be selected or not

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed() : \BuildException

inherited

### Response

`\BuildException`

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

inherited

{@inheritdoc}

## Sets a description of the current data type. It will be useful in commenting what we are doing.

    setDescription(string $desc) : void

inherited

### Arguments

#### $desc

`string`

## Allows all selectors to indicate a setup error. Note that only the first error message is recorded.

    setError(string $msg) : void

inherited

### Arguments

#### $msg

`string`

The error message any BuildException should throw.

## This sets whether to select a file if its dest file is present.

    setPresent(string $fp) : void

It could be a `negate` boolean, but by doing things this way, we get some documentation on how the system works. A user looking at the documentation should clearly understand that the ONLY files whose presence is being tested are those that already exist in the source directory, hence the lack of a `destonly` option.

### Arguments

#### $fp

`string`

An attribute set to either `srconly` or `both`.

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Set the value of the refid attribute.

    setRefid(\Reference $r) : void

inherited

Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do they must call parent::setRefid()

### Arguments

#### $r

`\Reference`

## The name of the file or directory which is checked for matching files.

    setTargetdir(\PhingFile $targetdir) : void

### Arguments

#### $targetdir

`\PhingFile`

the directory to scan looking for matching files.

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes() : \BuildException

inherited

### Response

`\BuildException`

## toString

    toString() : string

### Response

`string`

## Subclasses can use this to throw the requisite exception in isSelected() in the case of an error condition.

    validate()

inherited

throws |

## <p>Subclasses can override this method to provide checking of their state. So long as they call validate() from isSelected(), this will be called automatically (unless they override validate()).</p> <p>Implementations should check for incorrect settings and call setError() as necessary.</p>

    verifySettings()

inherited

### Properties

## targetdir

    targetdir :

### Type(s)

``

## mapperElement

    mapperElement :

### Type(s)

``

## map

    map :

### Type(s)

``

## destmustexist

    destmustexist :

### Type(s)

``

## filePresence

    filePresence :

static

### Type(s)

``

## errmsg

    errmsg : string

inherited

var |

### Type(s)

`string`

## The descriptin the user has set.

    description : string

inherited

var |

### Type(s)

`string`

## Value to the refid attribute.

    ref : \Reference

inherited

var |

### Type(s)

`\Reference`

## Are we sure we don't hold circular references?

    checked : boolean

inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

var |

### Type(s)

`boolean`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`